//
// Fl_Native_File_Chooser_DEFAULT.H -- FLTK native OS file chooser widget
//
// Copyright 2004 by Greg Ercolano.
// March 2005 - wrapper around Fl_File_Chooser by Nathan Vander Wilt
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//

// Use FLTK BROWSER
#include <FL/Fl_File_Chooser.H>

class Fl_Native_File_Chooser {
public:
    enum Type {
	BROWSE_FILE = 0,
        BROWSE_DIRECTORY,
	BROWSE_MULTI_FILE,
	BROWSE_MULTI_DIRECTORY,
	BROWSE_SAVE_FILE,
	BROWSE_NOSAVE_DIRECTORY
    };

private:
    void Ctor(Type);
    char  *_errmsg;		// error message
    void errmsg(const char *msg);
    int type_fl_file(Type);
    Fl_File_Chooser  *file_chooser;
public:
    Fl_Native_File_Chooser();
    Fl_Native_File_Chooser(Type);
    ~Fl_Native_File_Chooser();
    void type(Type);
    int show();
    const char *errmsg();
    const char* filename() const;
    const char* filename(int i) const;
    void title(const char *);
    const char* title() const;
    const char *filter() const;
    void filter(const char *);
    int size();
    int total_filenames() const;           // XXX/TBD undocumented, but used by main.cxx - same as size?
    void preset_dirname(const char *val);  // undocumented
    const char* preset_dirname() const;    // undocumented
};
